Plagued = LibStub("AceAddon-3.0"):NewAddon("Plagued", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
Plagued.MINOR_VERSION = tonumber(("$Revision: 7 $"):match("%d+"))
local L = LibStub("AceLocale-3.0"):GetLocale("Plagued")
local Plagued = Plagued
--


--[[
      VARIABLES ----------------------------------------------------------------------------------------------------------------
  ]]

local unboundPlague = GetSpellInfo(72856) -- Unbound Plague
local testDebuff
--[===[@debug@
testDebuff = 58600 -- Restricted Flight Area
--@end-debug@]===]
local seconds = 10



--[[
      UPVALUES -----------------------------------------------------------------------------------------------------------------
  ]]
  
local _G = getfenv(0)
local format = _G.format



--[[
      INITIALIZATION -----------------------------------------------------------------------------------------------------------
  ]]

function Plagued:OnInitialize()
end


function Plagued:OnEnable()
	-- Register for events
	self:UnregisterAllEvents()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "OnCombatEvent")

	--[===[@debug@
	self:Print(L["Loaded"])
	--@end-debug@]===]
end


function Plagued:OnDisable()
	-- Cancel all timers
	self:CancelAllTimers()
	self:UnregisterAllEvents()

	--[===[@debug@
	self:Print(L["Disabled"])
	--@end-debug@]===]
end



--[[
      EVENTS -------------------------------------------------------------------------------------------------------------------
  ]]

function Plagued:OnCombatEvent(event, timestamp, eventType, srcGuid, srcName, srcFlags, dstGuid, dstName, dstFlags, ...)
	if UnitInRaid("player") then
		if eventType == "SPELL_AURA_APPLIED" then
			if dstName == UnitName("player") then
				local spellId, spellName, spellSchool, auraType = select(1, ...)
				if spellName == unboundPlague or spellId == testDebuff then
				
					self:Start()
					
				end -- unbound plague
			end -- player is you
			
		elseif eventType == "SPELL_AURA_REMOVED" then
			if dstName == UnitName("player") then
				local spellId, spellName, spellSchool, auraType = select(1, ...)
				if spellName == unboundPlague or spellId == testDebuff then
				
					self:CancelAllTimers()
					SendChatMessage("----", "SAY")
					
				end -- unbound plague
			end -- player is you
		
		end -- eventType
	end -- in a raid
end


function Plagued:Start()
	self:CancelAllTimers()
	seconds = 10
	self:OnTimer()
	self:ScheduleRepeatingTimer("OnTimer", 1.0)
end


function Plagued:OnTimer()
	if seconds and seconds > 0 then
		SendChatMessage(format(L["Help me in %d seconds!"], seconds), "SAY")
	elseif seconds and seconds == 0 then
		SendChatMessage(L["Help me NOW!"], "SAY")
		self:CancelAllTimers()
	else
		self:CancelAllTimers()
	end
	if seconds then seconds = seconds - 1 end
end

